// File:  testbench.v
// Date:  01/01/2005
// Name:  Eric Crabill
// 
// This is a top level testbench for the
// pcm design, which is part of the EE178
// Lab #3 assignment.

// The `timescale directive specifies what
// the simulation time units are (1 ns here)
// and what the simulator timestep should be
// (1 ps here).

`timescale 1 ns / 1 ps

module pcm_testbench_v_tf();

  // Declare wires to be driven by the outputs
  // of the design, and regs to drive the inputs.
  // The testbench will be in control of inputs
  // to the design, and will check the outputs.
  // Then, instantiate the design to be tested.

  wire aud, busy;
  reg init, clk, rst;
  reg [1:0] sel;

  pcm my_pcm (.init(init), .sel(sel), .clk(clk), .rst(rst), .aud(aud), .busy(busy));

  // Describe two processes that generate clock
  // and reset signals.  The clock is 50 MHz, and
  // let's assume the reset button is pressed at
  // time zero for a short period of time, then
  // released.

  always
  begin
    clk = 1'b1;
    #10;
    clk = 1'b0;
    #10;
  end

  initial
  begin
    rst = 1'b1;
    #110;
    rst = 1'b0;
  end

  // Assign values to the input signals and
  // check the output results.  This template
  // is meant to get you started, you can modify
  // it as you see fit.  If you simply run it as
  // provided, you will need to visually inspect
  // the output waveforms to see if they make
  // sense...  What you should expect depends on
  // your sampled audio data, but in any case you
  // should see the aud output toggling frequently.

  initial
  begin
    $display("If simulation ends prematurely, restart");
    $display("using 'run -all' on the command line.");
    init <= 1'b0;
    sel <= 2'b00;
    // Wait until reset is deasserted.
    @(negedge rst);
    $display("Reset is deasserted...");
    $display("Prepare to wait a long time...");
    // Wait a few clock cycles, and pulse init signal.
    @(posedge clk);
    @(posedge clk);
    init <= 1'b1;
    @(posedge clk);
    @(posedge clk);
    init <= 1'b0;
    // Now simply wait and see what happens.
    #5000;
    $display("Checkpoint, simulation time is %t",$time);
    #5000;
    $display("Checkpoint, simulation time is %t",$time);
    #5000;
    $display("Checkpoint, simulation time is %t",$time);
    #5000;
    $display("Checkpoint, simulation time is %t",$time);
    #5000;
    $display("Checkpoint, simulation time is %t",$time);
    // End the simulation.
    $display("Simulation is over, check the waveforms.");
    $stop;
  end

endmodule